variables:
  manylinux: false
  coverage: false

resources:
  containers:
  - container: manylinux1
    image: pyca/cryptography-manylinux1:x86_64

jobs:
- job: Prebuild
  displayName: Pre-build checks

  pool:
    vmImage: ubuntu-16.04

  steps:
  - template: ./prebuild-checks.yml


- job: Docs_PR
  displayName: Docs PR
  dependsOn: Prebuild
  condition: and(succeeded(), eq(dependencies.Prebuild.outputs['docs.run'], 'true'))

  pool:
    vmImage: ubuntu-16.04

  steps:
  - template: ./docs-steps.yml


- job: macOS_PR_Tests
  displayName: macOS PR Tests
  dependsOn: Prebuild
  condition: and(succeeded(), eq(dependencies.Prebuild.outputs['tests.run'], 'true'))

  variables:
    testRunTitle: '$(system.pullRequest.TargetBranch)-macos'
    testRunPlatform: macos

  pool:
    vmImage: xcode9-macos10.13

  steps:
  - template: ./macos-steps.yml
    parameters:
      targetBranch: $(System.PullRequest.TargetBranch)


- job: Ubuntu_PR_Tests
  displayName: Ubuntu PR Tests
  dependsOn: Prebuild
  condition: and(succeeded(), eq(dependencies.Prebuild.outputs['tests.run'], 'true'))

  pool:
    vmImage: ubuntu-16.04

  variables:
    testRunTitle: '$(system.pullRequest.TargetBranch)-linux'
    testRunPlatform: linux
    openssl_version: 1.1.0j

  steps:
  - template: ./posix-steps.yml
    parameters:
      dependencies: apt


- job: ManyLinux1_PR_Tests
  displayName: ManyLinux1 PR Tests
  dependsOn: Prebuild
  condition: |
    and(
        and(
            succeeded(),
            eq(variables['manylinux'], 'true')
        ),
        eq(dependencies.Prebuild.outputs['tests.run'], 'true')
    )

  pool:
    vmImage: ubuntu-16.04

  container: manylinux1

  variables:
    testRunTitle: '$(system.pullRequest.TargetBranch)-manylinux1'
    testRunPlatform: manylinux1
    openssl_version: ''

  steps:
  - template: ./posix-steps.yml
    parameters:
      dependencies: yum
      sudo_dependencies: ''
      xvfb: false
      patchcheck: false


- job: Ubuntu_Coverage_PR_Tests
  displayName: Ubuntu PR Tests (coverage)
  dependsOn: Prebuild
  condition: |
    and(
        and(
            succeeded(),
            eq(variables['coverage'], 'true')
        ),
        eq(dependencies.Prebuild.outputs['tests.run'], 'true')
    )

  pool:
    vmImage: ubuntu-16.04

  variables:
    testRunTitle: '$(Build.SourceBranchName)-linux-coverage'
    testRunPlatform: linux-coverage
    openssl_version: 1.1.0j

  steps:
  - template: ./posix-steps.yml
    parameters:
      dependencies: apt
      coverage: true


- job: Windows_PR_Tests
  displayName: Windows PR Tests
  dependsOn: Prebuild
  condition: and(succeeded(), eq(dependencies.Prebuild.outputs['tests.run'], 'true'))

  pool:
    vmImage: vs2017-win2016

  strategy:
    matrix:
      win32:
        arch: win32
        buildOpt:
        testRunTitle: '$(System.PullRequest.TargetBranch)-win32'
        testRunPlatform: win32
      win64:
        arch: amd64
        buildOpt: '-p x64'
        testRunTitle: '$(System.PullRequest.TargetBranch)-win64'
        testRunPlatform: win64
    maxParallel: 2

  steps:
  - template: ./windows-steps.yml
    parameters:
      targetBranch: $(System.PullRequest.TargetBranch)
